<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Объекты</title>
</head>
<body>
<script>
var studentsAndPoints = ['Алексей Петров',0, 'Ирина Овчинникова',60,'Глеб Стукалов',30,'Антон Павлович',30,'Виктория Заровская',30,'Алексей Левенец',70,'Тимур Вамуш',30,'Евгений Прочан',60,'Александр Малов',0];
/*students[0]={name:'Алексей Петров',point:0};
students[1]={name:'Ирина Овчинникова',point:60};
students[2]={name:'Глеб Стукалов',point:30};
students[3]={name:'Антон Павлович',point:30};
students[4]={name:'Виктория Заровская',point:30};
students[5]={name:'Алексей Левенец',point:70};
students[6]={name:'Тимур Вамуш',point:30};
students[7]={name:'Евгений Прочан',point:60};
students[8]={name:'Александр Малов',point:0};
*/ 
/*Созданиие массива students*/ 
var students = [];
var studentShow = function(){
	document.write('Студент '+this.name+ ' набрал '+this.point+' баллов <br /><br /><br />' );
};
for(var i = 0; i < studentsAndPoints.length; i+=2){
	students.push({name:  studentsAndPoints[i], point: studentsAndPoints[i+1], show: studentShow});
};
students[4].show();

/*Добавить в список студентов «Николай Фролов» и «Олег Боровой». У них пока по 0 быллов*/
students.push({name:"Николай Фролов",point:0, show:studentShow},{name:"Олег Боровой",point:0,show:studentShow});

/*Увеличить баллы студентам «Ирина Овчинникова» и «Александр Малов» на 30, а Николаю Фролову на 10.*/
function pushPoints(name, addPoints){
  students.find(function(student){
    if(student.name == name){
    return student.point += addPoints;
    }
  });
}

pushPoints('Ирина Овчинникова', 30);
pushPoints('Александр Малов', 30);
pushPoints('Николай Фролов', 10);

/*Вывести список студентов набравших 30 и более баллов без использования циклов*/
function studentsList(){
	students.forEach(function(student,i){
		if(students[i].point >= 30){
			document.write('Студент '+student.name+ ' набрал '+students[i].point+ ' баллов <br />');
		}
	});
}
studentsList();
 
/*Учитывая что каждая сделанная работа оценивается в 10 баллов, 
добавить всем студентам поле worksAmount равное кол-ву сделанных работ.*/

students.forEach(function (student) {
   return student.worksAmount = student.point/10;
});

/*Вывод всего массива для проверки*/
document.write('<br /><br /><br />');
function myShow(){
	for(var i in students){ 
	document.write('Студент: '+students[i].name +' | Баллы: '+students[i].point +  ' | Колличество работ: ' +students[i].worksAmount+'<br />');
	}
}
myShow();

/*Дополнительное задание: добавить объекту students метод findByName, 
который принимает на вход имя студента и возвращает соответствующий объект, либо undefined.*/ 
document.write('<br /><br />');

var studentFindByName = function(nameStudent){
	if(this.name == nameStudent){
		document.write('Студент: '+this.name +' | Баллы: '+this.point +  ' | Колличество работ: ' +this.worksAmount+'<br />');
	}
	else{
		document.write(undefined);
	}
}
students.forEach(function (student) {
	return student.findByName = studentFindByName;
});
students[1].findByName('Ирина Овчинникова');


</script>	

</body>
</html>